searchNodes=[{"doc":"Mammoth: A STOMP client. Use Mammoth as the primary API and Mammoth.Message for working with received messages. My recommendation is to start mammoth from within your own implementation of the callback handler, and to put the callback handler itself into a supervisor. You shouldn't try to reconnect a disconnected mammoth process, at the moment the internal state may be inconsistent. Instead, start a new instance. Again, this is easily handled with OTP. Example { :ok , callback_pid } = Mammoth.DefaultCallbackHandler . start_link { :ok , pid } = Mammoth . start_link ( callback_pid ) :ok = Mammoth.DefaultCallbackHandler . set_mammoth_pid ( callback_pid , pid ) Mammoth . connect ( pid , { 127 , 0 , 0 , 1 } , 61613 , &quot;/&quot; , &quot;admin&quot; , &quot;admin&quot; ) Mammoth . subscribe ( pid , &quot;foo.bar&quot; , :client ) Mammoth . disconnect ( pid ) Starting in a supervision tree children = [ worker ( Mammoth , [ %{ } , [ name : Mammoth ] ] ) ]","ref":"Mammoth.html","title":"Mammoth","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mammoth.html#child_spec/1","title":"Mammoth.child_spec/1","type":"function"},{"doc":"Connect to server. host must be inet:socket_address() | inet:hostname() , for example {127,0,0,1} or 'example.com' . virtual_host ( host header) is mandatory in STOMP 1.2, behaviour is server defined. Default on RabbitMQ would be &quot;/&quot; . https://stomp.github.io/stomp-specification-1.2.html#CONNECT_or_STOMP_Frame","ref":"Mammoth.html#connect/7","title":"Mammoth.connect/7","type":"function"},{"doc":"Disconnect from server.","ref":"Mammoth.html#disconnect/1","title":"Mammoth.disconnect/1","type":"function"},{"doc":"Requests disconnection from the remote server","ref":"Mammoth.html#handle_call/3","title":"Mammoth.handle_call/3","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Mammoth.html#init/1","title":"Mammoth.init/1","type":"function"},{"doc":"Receive messages from the TCP socket. Is called automatically when necessary. Should not be called manually.","ref":"Mammoth.html#receive/2","title":"Mammoth.receive/2","type":"function"},{"doc":"Send an ACK message to the remote server for the specified frame if the 'ack' header is present","ref":"Mammoth.html#send_ack_frame/3","title":"Mammoth.send_ack_frame/3","type":"function"},{"doc":"Send an ACK message to the remote server for the specified frame ID (referenced in the MESSAGE ack header)","ref":"Mammoth.html#send_ack_id/3","title":"Mammoth.send_ack_id/3","type":"function"},{"doc":"Send a frame to the remote server","ref":"Mammoth.html#send_frame/2","title":"Mammoth.send_frame/2","type":"function"},{"doc":"Send an NACK message to the remote server for the specified frame","ref":"Mammoth.html#send_nack_frame/3","title":"Mammoth.send_nack_frame/3","type":"function"},{"doc":"Send an NACK message to the remote server for the specified frame ID (referenced in the MESSAGE ack header)","ref":"Mammoth.html#send_nack_id/3","title":"Mammoth.send_nack_id/3","type":"function"},{"doc":"Send a SEND message to the remote server content-length header will be automatically added.","ref":"Mammoth.html#send_send/4","title":"Mammoth.send_send/4","type":"function"},{"doc":"","ref":"Mammoth.html#start_link/3","title":"Mammoth.start_link/3","type":"function"},{"doc":"Subscribe to a queue. Note that if you set ack_mode to :client_individual or :client, you must send ACK frames when you receive MESSAGE frames (not required with :auto) https://stomp.github.io/stomp-specification-1.2.html#SUBSCRIBE_ack_Header","ref":"Mammoth.html#subscribe/4","title":"Mammoth.subscribe/4","type":"function"},{"doc":"Unsubscribe from a queue.","ref":"Mammoth.html#unsubscribe/2","title":"Mammoth.unsubscribe/2","type":"function"},{"doc":"Default callback handler, useful for basic testing, and as a complete example for how to implement your own callback handler Example { :ok , callback_pid } = Mammoth.DefaultCallbackHandler . start_link { :ok , mammoth_pid } = Mammoth . start_link ( callback_pid )","ref":"Mammoth.DefaultCallbackHandler.html","title":"Mammoth.DefaultCallbackHandler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mammoth.DefaultCallbackHandler.html#child_spec/1","title":"Mammoth.DefaultCallbackHandler.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Mammoth.DefaultCallbackHandler.html#init/1","title":"Mammoth.DefaultCallbackHandler.init/1","type":"function"},{"doc":"Set Mammoth PID. This is to make examples simpler to follow, my recommendation is instead to start and link Mammoth from within your own callback genserver implementation","ref":"Mammoth.DefaultCallbackHandler.html#set_mammoth_pid/2","title":"Mammoth.DefaultCallbackHandler.set_mammoth_pid/2","type":"function"},{"doc":"","ref":"Mammoth.DefaultCallbackHandler.html#start_link/0","title":"Mammoth.DefaultCallbackHandler.start_link/0","type":"function"},{"doc":"Representation of sent or received messages. Each message has three components: command list of headers body The command is an atom and only commands specified in the STOMP specification are allowed. Each header is a 2-tuple {&quot;header-key&quot;, &quot;header-value&quot;} . The body is a binary. All commands are: :ack :nack :begin :commit :abort :send :message :error :connect :connected :disconnect :receipt :subscribe :unsubscribe","ref":"Mammoth.Message.html","title":"Mammoth.Message","type":"module"},{"doc":"Apply &quot;Value Decoding&quot; for header values. See https://stomp.github.io/stomp-specification-1.2.html#Valuea_Encoding Examples iex&gt; Mammoth.Message.apply_value_decoding(&lt;&lt;&quot;foo&quot;, 92, 92, &quot;bar&quot;&gt;&gt;) &lt;&lt;&quot;foo&quot;, 92, &quot;bar&quot;&gt;&gt; iex&gt; Mammoth.Message.apply_value_decoding(&lt;&lt;&quot;foo&quot;, 92, 99, &quot;bar&quot;&gt;&gt;) &quot;foo:bar&quot; iex&gt; Mammoth.Message.apply_value_decoding(&lt;&lt;&quot;foo&quot;, 92, 110, &quot;bar&quot;&gt;&gt;) &lt;&lt;&quot;foo&quot;, 10, &quot;bar&quot;&gt;&gt; iex&gt; Mammoth.Message.apply_value_decoding(&lt;&lt;&quot;foo&quot;, 92, 114, &quot;bar&quot;&gt;&gt;) &lt;&lt;&quot;foo&quot;, 13, &quot;bar&quot;&gt;&gt;","ref":"Mammoth.Message.html#apply_value_decoding/1","title":"Mammoth.Message.apply_value_decoding/1","type":"function"},{"doc":"","ref":"Mammoth.Message.html#format/1","title":"Mammoth.Message.format/1","type":"function"},{"doc":"","ref":"Mammoth.Message.html#format_headers/1","title":"Mammoth.Message.format_headers/1","type":"function"},{"doc":"Get header by key. Returns {:ok, value} or {:error, :notfound} if the header does not exist.","ref":"Mammoth.Message.html#get_header/2","title":"Mammoth.Message.get_header/2","type":"function"},{"doc":"Checks if a header exists, by both key and value.","ref":"Mammoth.Message.html#has_header/2","title":"Mammoth.Message.has_header/2","type":"function"},{"doc":"Turn list of raw header lines into key value pairs. iex&gt; Mammoth.Message.normalize_headers([&lt;&lt;&quot;message-id:ID&quot;, 92, 99, &quot;b39dd&quot;&gt;&gt;]) [{&quot;message-id&quot;, &quot;ID:b39dd&quot;}]","ref":"Mammoth.Message.html#normalize_headers/1","title":"Mammoth.Message.normalize_headers/1","type":"function"},{"doc":"","ref":"Mammoth.Message.html#parse/1","title":"Mammoth.Message.parse/1","type":"function"},{"doc":"Splits a string into two, either at the first null byte, or at content_length if non-nil. Terminal null byte is still required and consumed when specifying content_length Examples iex&gt; Mammoth.Message . read_until_end ( &lt;&lt; 65 , 66 , 0 , 67 , 68 &gt;&gt; , nil ) { :ok , &quot;AB&quot; , &quot;CD&quot; } iex&gt; Mammoth.Message . read_until_end ( &lt;&lt; 65 , 66 , 0 &gt;&gt; , nil ) { :ok , &quot;AB&quot; , &quot;&quot; } iex&gt; Mammoth.Message . read_until_end ( &lt;&lt; 0 , 67 , 68 &gt;&gt; , nil ) { :ok , &quot;&quot; , &quot;CD&quot; } iex&gt; Mammoth.Message . read_until_end ( &lt;&lt; 65 , 66 &gt;&gt; , nil ) { :incomplete , &quot;AB&quot; }","ref":"Mammoth.Message.html#read_until_end/2","title":"Mammoth.Message.read_until_end/2","type":"function"},{"doc":"","ref":"Mammoth.Message.html#set_content_length_header/2","title":"Mammoth.Message.set_content_length_header/2","type":"function"},{"doc":"Removes single CR / CRLF pair at the beginning of the string. Examples iex&gt; Mammoth.Message . skip_newline ( &quot; \\n \\n \\n Hello&quot; ) &quot; \\n \\n Hello&quot; iex&gt; Mammoth.Message . skip_newline ( &quot;Hello&quot; ) &quot;Hello&quot; iex&gt; Mammoth.Message . skip_newline ( &quot; \\r \\n \\r \\n Hello&quot; ) &quot; \\r \\n Hello&quot;","ref":"Mammoth.Message.html#skip_newline/1","title":"Mammoth.Message.skip_newline/1","type":"function"},{"doc":"","ref":"Mammoth.Receiver.html","title":"Mammoth.Receiver","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mammoth.Receiver.html#child_spec/1","title":"Mammoth.Receiver.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Mammoth.Receiver.html#handle_continue/2","title":"Mammoth.Receiver.handle_continue/2","type":"function"},{"doc":"","ref":"Mammoth.Receiver.html#handle_response/2","title":"Mammoth.Receiver.handle_response/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Mammoth.Receiver.html#init/1","title":"Mammoth.Receiver.init/1","type":"function"},{"doc":"","ref":"Mammoth.Receiver.html#listen/1","title":"Mammoth.Receiver.listen/1","type":"function"},{"doc":"","ref":"Mammoth.Receiver.html#start_link/1","title":"Mammoth.Receiver.start_link/1","type":"function"},{"doc":"","ref":"Mammoth.Receiver.html#stop/1","title":"Mammoth.Receiver.stop/1","type":"function"},{"doc":"","ref":"Mammoth.Socket.html","title":"Mammoth.Socket","type":"module"},{"doc":"","ref":"Mammoth.Socket.html#connect/2","title":"Mammoth.Socket.connect/2","type":"function"},{"doc":"","ref":"Mammoth.Socket.html#receive/2","title":"Mammoth.Socket.receive/2","type":"function"},{"doc":"","ref":"Mammoth.Socket.html#send/2","title":"Mammoth.Socket.send/2","type":"function"},{"doc":"Keep track of subscriptions to topics or queues. Example { :ok , pid } = Subscriber . start_link ( ) Subscriber . subscribe ( pid , &quot;foo.bar&quot; ) Subscriber . subscribe ( pid , &quot;foo2.bar&quot; ) %{ id : id } = Subscriber . get_subscription ( pid , &quot;foo.bar&quot; ) Subscriber . unsubscribe ( pid , &quot;foo2.bar&quot; )","ref":"Mammoth.Subscriber.html","title":"Mammoth.Subscriber","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mammoth.Subscriber.html#child_spec/1","title":"Mammoth.Subscriber.child_spec/1","type":"function"},{"doc":"","ref":"Mammoth.Subscriber.html#get_subscription/2","title":"Mammoth.Subscriber.get_subscription/2","type":"function"},{"doc":"","ref":"Mammoth.Subscriber.html#has_subscription?/2","title":"Mammoth.Subscriber.has_subscription?/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Mammoth.Subscriber.html#init/1","title":"Mammoth.Subscriber.init/1","type":"function"},{"doc":"","ref":"Mammoth.Subscriber.html#next_id/1","title":"Mammoth.Subscriber.next_id/1","type":"function"},{"doc":"","ref":"Mammoth.Subscriber.html#start_link/1","title":"Mammoth.Subscriber.start_link/1","type":"function"},{"doc":"","ref":"Mammoth.Subscriber.html#stop/1","title":"Mammoth.Subscriber.stop/1","type":"function"},{"doc":"","ref":"Mammoth.Subscriber.html#subscribe/3","title":"Mammoth.Subscriber.subscribe/3","type":"function"},{"doc":"","ref":"Mammoth.Subscriber.html#unsubscribe/2","title":"Mammoth.Subscriber.unsubscribe/2","type":"function"}]